package com.caimei365.manager.service.hehe.order.impl;

import com.caimei365.manager.dao.hehe.HeHeOrderDao;
import com.caimei365.manager.entity.PaginationVo;
import com.caimei365.manager.entity.ResponseJson;
import com.caimei365.manager.entity.order.CmOrder;
import com.caimei365.manager.entity.order.CmReturnedPurchase;
import com.caimei365.manager.service.hehe.order.HeHeOrderService;
import com.github.pagehelper.PageHelper;
import org.apache.commons.collections4.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;


@Service
public class HeHeOrderServiceImpl implements HeHeOrderService {

    @Autowired
    private HeHeOrderDao orderDao;

    @Override
    public ResponseJson<PaginationVo<CmOrder>> orderList(CmOrder cmOrder, int pageNum, int pageSize) {
        PageHelper.startPage(pageNum, pageSize);
        List<CmOrder> list = orderDao.findOrderList(cmOrder);
        List<Integer> oId = list.stream().map(CmOrder::getOrderId).collect(Collectors.toList());
        //从查询到的订单列表中 找到正在退款中的订单集合
        List<Integer> orderIdsInReturn = null;
        if (CollectionUtils.isNotEmpty(oId)) {
            orderIdsInReturn = orderDao.findOrderIdInReturnPurchase(oId);
        }
        for (CmOrder order : list) {
            // todo 审核中标记，优化到findList里面
            if (orderIdsInReturn != null && orderIdsInReturn.contains(order.getOrderId())) {
                order.setReturnedPurchaseStatus(1);
            } else {
                order.setReturnedPurchaseStatus(0);
            }
        }
        PaginationVo<CmOrder> page = new PaginationVo<>(list);
        return ResponseJson.success(page);
    }

    @Override
    public ResponseJson<PaginationVo<CmReturnedPurchase>> returnedPurchaseList(CmReturnedPurchase returnedPurchase, int pageNum, int pageSize) {
        returnedPurchase.setOrderType(2);
        PageHelper.startPage(pageNum, pageSize);
        List<CmReturnedPurchase> list = orderDao.findReturnList(returnedPurchase);
        PaginationVo<CmReturnedPurchase> page = new PaginationVo<>(list);
        return ResponseJson.success(page);
    }
}
