package com.caimei365.manager.service.hehe.user.impl;


import com.caimei.utils.StringUtil;
import com.caimei365.manager.dao.hehe.HeHeProductDao;
import com.caimei365.manager.dao.hehe.HeHeUserDao;
import com.caimei365.manager.entity.PaginationVo;
import com.caimei365.manager.entity.ResponseJson;
import com.caimei365.manager.entity.caimei.CmUser;
import com.caimei365.manager.entity.hehe.product.HeHeSalesActivityProduct;
import com.caimei365.manager.entity.hehe.user.HeHeUser;
import com.caimei365.manager.service.hehe.user.HeHeUserService;
import com.github.pagehelper.PageHelper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

@Service
@Slf4j
public class HeHeUserServiceImpl implements HeHeUserService {

    @Autowired
    private HeHeUserDao userDao;
    @Autowired
    private HeHeProductDao productDao;

    @Override
    public ResponseJson<PaginationVo<HeHeUser>> SalesList(HeHeUser man, int pageNum, int pageSize) {
        man.setUserIdentity(2);
        PageHelper.startPage(pageNum, pageSize);
        List<HeHeUser> list = userDao.findList(man);
        PaginationVo<HeHeUser> page = new PaginationVo<>(list);
        return ResponseJson.success(page);
    }

    @Override
    public ResponseJson<PaginationVo<HeHeUser>> userList(HeHeUser man, int pageNum, int pageSize) {
        PageHelper.startPage(pageNum, pageSize);
        List<HeHeUser> list = userDao.findList(man);
        PaginationVo<HeHeUser> page = new PaginationVo<>(list);
        return ResponseJson.success(page);
    }

    @Override
    public ResponseJson saveSales(HeHeUser man) {
        Integer userId = userDao.findMobileOnly(man);
        if (userId != null && userId > 0) {
            return ResponseJson.error("手机号重复，请更换手机号");
        }
        CmUser user = new CmUser();
        user.setBindMobile("H" + man.getMobile());
        user.setUserName(man.getName());
        user.setName(man.getName());
        if (null == man.getId()) {
            man.setUserIdentity(2);
            //保存user表
            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String currentTime = simpleDateFormat.format(new Date());
            user.setPassword("HeHe");
            //6:呵呵商城用户
            user.setUserIdentity(6);
            user.setRegisterUserTypeId(6);
            user.setRegisterTime(currentTime);
            user.setValidFlag(1);
            userDao.insertCmUser(user);
            man.setUserId(user.getUserId());
        } else {
            user.setUserId(man.getUserId());
            userDao.updateCmUser(user);
        }
        userDao.saveSales(man);
        return ResponseJson.success();
    }

    @Override
    public ResponseJson addSaleActivityProducts(Integer userId, String productIds) {
        if (StringUtil.isNotBlank(productIds)) {
            String[] strings = productIds.split(",");
            HeHeSalesActivityProduct product = new HeHeSalesActivityProduct();
            product.setUserId(userId);
            for (String productId : strings) {
                if (StringUtil.isNotBlank(productId)) {
                    product.setProductId(Integer.valueOf(productId));
                    Integer activityId = productDao.findActivityByProductId(productId);
                    product.setActivityId(activityId);
                    productDao.insertUserActivity(product);
                }
            }
        }
        return ResponseJson.success();
    }

    @Override
    public ResponseJson delSaleActivityProducts(Integer userId, Integer productId) {
        productDao.deleteUserActivity(userId, productId);
        return ResponseJson.success();
    }
}
